#ifndef ARGS_H
#define ARGS_H
#include "type.h"

struct argstuff {
    /* globals */
    Atom *libs;			/* list of libraries that we need */
    Atom *arglist;		/* augmented list of arguments */

    /* local use by process_args () */
    int skip;			/* # of args to skip processing.  normally 0.
				   set by fn_skip() */
    Atom *mode;			/* current link mode (string containing
				 * "d", "s", or "ds") d=dynamic, s=static */
    Atom *dict;			/* dictionary of functions that are callable
				 * from the config file */
    char **args;		/* pointer to current arg within argv
				 * used by fn_args() to allow config file
				 * to reference command-line arguments */
    Atom *bound_libname;	/* library name associated with this
				 * argument.  set by fn_bind2lib()*/
    int bound_nargs;		/* number of arguments bound to
				 * bound_libname.  set by fn_bind2lib() */
} argstuff;

char **list2argv (Atom *list);
void process_args (char **argv, Atom *config);
Atom *path2list (char *s);
char *list2path (Atom *list);
Atom *make_child_arglist (Atom *arglist, Atom *liblist);

#endif /* ARGS_H */
