#include <stdio.h>
#include "concat.h"
#include "httpget.h"

/*
 * download a URL into a local file.  used by install scripts
 * via "nb -download url filename" to download files that
 * couldn't be downloaded from netlib.
 */

int
nb_download (char *srcurl, char *dstfile)
{
    FILE *in, *out;
    char buf[8*1024];
    int nread;

    if ((in = http_get_internal (srcurl, 0, NULL)) == NULL) {
	fprintf (stderr, "can't download\n %s\n", srcurl);
	return 1;
    }
    if ((out = fopen (dstfile, "w")) == NULL) {
	perror (concat ("can't open \"", dstfile, "\" for writing", NULL));
	return 1;
    }
    while ((nread = fread (buf, sizeof (char), sizeof (buf), in)) > 0) {
	if (fwrite (buf, sizeof (char), nread, out) != nread)
	    goto fail;
    }
    fclose (in);
    fclose (out);
    return 0;

 fail:
    fclose (in);
    fclose (out);
    unlink (dstfile);
    return 1;
}
