#include <stdio.h>
#include "type.h"

Atom *
reverse (Atom *a)
{
    Atom *result = NULL;

    for (; !nullp (a); a = next (a))
	result = cons (this (a), result);
    return result;
}

Atom *
prepend_to_each (Atom *a, Atom *list)
{
    Atom *result = NULL;

    for (; !nullp(list); list=next(list))
	result = cons (cons (a, this (list)), result);
    return reverse (result);
}

Atom *
cartesian (Atom *list_of_lists)
{
    Atom *result = NULL;
    Atom *new_result = NULL;
    Atom *lol;

    result = NULL;
    for (lol = this (list_of_lists); !nullp (lol); lol = next (lol))
	result = cons (cons (this (lol), NULL), result);
    new_result = reverse (result);
    /* unref (result); */
    result = new_result;
    printf ("initial result = ");
    print_atom (result);
    printf ("\n");

    for (lol = next (list_of_lists); !nullp (lol); lol = next (lol)) {
	Atom *list = this (lol);
	Atom *l;
	
	printf ("list = ");
	print_atom (list);
	printf ("\nresult = ");
	print_atom (result);
	printf ("\n");

	new_result = NULL;
	for (l = list; !nullp (l); l = next (l)) {
	    Atom *item = this (l);
	    Atom *r;
	    
	    printf ("prepending ");
	    print_atom (item);
	    printf (" to each element of \n");
	    print_atom (result);
	    printf ("\n");

	    for (r = result; !nullp(r); r = next(r))
		new_result = cons (cons (item, this (r)), new_result);
	}
	/* unref (result); */
	result = reverse(new_result);
    }
    return result;
}

Atom *
generate_clists (Atom *lib_list)
{
    Atom *foo;
    Atom *bar;
    Atom *ll;

    bar = NULL;
    for (ll = lib_list; !nullp (ll); ll = next (ll)) {
	Atom *lib = this (ll);
	Atom *libname = this (lib);
	Atom *inst;

	foo = NULL;
	for (inst = next (lib); !nullp (inst); inst = next (inst)) {
	    foo = cons (cons (libname, this (inst)), foo);
	}
	bar = cons (cons (reverse (foo), NULL), bar);
    }
    print_atom (bar);
    printf ("\n");
    return cartesian (reverse (bar));
}

/*

(("lib1"
  (("n1a1" "v1a1") ("n1b1" "v1b1") ("n1c1" "v1c1"))
  (("n1a2" "v1a2") ("n1b2" "v1b2") ("n1c2" "v1c2"))
  (("n1a3" "v1a3") ("n1b3" "v1b3") ("n1c3" "v1c2")))
 ("lib2"
  (("n2a1" "v1a1") ("n2b1" "v1b1") ("n2c1" "v1c1"))
  (("n2a2" "v1a2") ("n2b2" "v1b2") ("n2c2" "v1c2"))
  (("n2a3" "v1a3") ("n2b3" "v1b3") ("n2c3" "v1c2"))))
  
 */

Atom *
c2s (char *s1, char *s2)
{
    return cons (string (s1), string (s2));
}

main ()
{
    Atom *zot =
	list (
	      list (string ("lib1"),
		    list (string ("url1"),
			  c2s ("a1", "a"), c2s ("a2", "b"),
			  c2s ("a3", "c"), NULL),
		    list (string ("url2"),
			  c2s ("a1", "w"), c2s ("a2", "x"),
			  c2s ("c3", "y"), NULL),
		    list (string ("url3"),
			  c2s ("a1", "d"), c2s ("a2", "d"),
			  c2s ("a3", "f"), NULL),
		    NULL),
	      list (string ("lib2"),
		    list (string ("url4"),
			  c2s ("a1", "A"), c2s ("a2", "B"),
			  c2s ("a3", "C"), NULL),
		    list (string ("url5"),
			  c2s ("a1", "D"), c2s ("a2", "E"),
			  c2s ("a3", "F"), NULL),
		    list (string ("url6"),
			  c2s ("a1", "G"), c2s ("a2", "H"),
			  c2s ("a3", "I"), NULL),
		    NULL),
	      NULL);

    print_atom (zot);
    printf ("\n");
    print_atom (generate_clists (zot));
    printf ("\n");
}
