#ifndef GLOBAL_H
#define GLOBAL_H 1

#include "type.h"

struct global {
    Atom *platform_attrs;
    char *platform_cpu;
    char *platform_os_name;
    char *platform_os_version;
    char *netbuild_arch;
    Atom *libpath;		/* library path - list of directories */
    int verbosity;
    Atom *constraints;		/* global constraints */
    char *path_prefix;
    char *platform_filename;	/* filename containing platform settings */
    enum {
	SHARED_LOCAL,
	SHARED_SYSTEM,
	SHARED_USER_SPECIFIED_DIR,
	SHARED_SCRIPT,
	SHARED_NETLOAD,
    } shared_lib_mode;		/* shared library link mode (not impl.) */
    char *shared_dir;
    Atom *server_list;		/* list of base URLs for package servers */
    Atom *liblist;		/* list of pre-loaded libraries */
    Atom *required_libs;	/* list of required libraries */
    char *argv0;
};

#endif
